(function() {
  // util.coffee    Copyright (c) 2016 Cloud Elements
  // All rights reserved. CLOUD ELEMENTS PROPRIETARY/CONFIDENTIAL.
  // Use is subject to license terms.
  var _, config, guid, os, restart, selfRestartUnix, selfRestartWin, spawn, verifyConfig;

  _ = require('lodash');

  os = require('os');

  config = require('../config');

  spawn = require('child_process').spawn;

  exports.guid = guid = function() {
    var s4;
    s4 = function() {
      return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
    };
    return s4() + s4() + s4() + s4();
  };

  exports.restart = restart = function(service) {
    if (!service) {
      if (os.platform() === 'win32') {
        return selfRestartWin();
      } else {
        return selfRestartUnix();
      }
    }
  };

  exports.selfRestartUnix = selfRestartUnix = function() {
    var child, shargs;
    shargs = [
      '-c',
      "sleep 3 ; " + _.map(process.argv,
      function(a) {
        return `\"${a}\"`;
      }).join(' ')
    ];
    child = spawn('sh', shargs, {
      detached: true,
      stdio: 'inherit'
    });
    return child.unref();
  };

  exports.selfRestartWin = selfRestartWin = function() {
    var child, shargs;
    shargs = [
      '/c',
      "timeout 3 >nul & " + _.map(process.argv,
      function(a) {
        return a.replace(/\ /g,
      '\\ ');
      }).join(' ')
    ];
    child = spawn('cmd.exe', shargs, {
      detached: true,
      stdio: 'inherit'
    });
    return child.unref();
  };

  exports.verifyConfig = verifyConfig = function(configPath, configData, cb) {
    return config.readRegistration(configPath, configData, function(err, regData) {
      if (err != null) {
        return cb(err);
      }
      configData.client.registration = regData;
      return config.readKey(configPath, configData, function(err, keydata) {
        configData.client.keydata = keydata;
        return cb(err, !(_.isEmpty(regData)));
      });
    });
  };

}).call(this);
