(function() {
  // emitter.coffee    Copyright (c) 2016 Cloud Elements
  // All rights reserved. CLOUD ELEMENTS PROPRIETARY/CONFIDENTIAL.
  // Use is subject to license terms.

  // A simple augmentation to EventEmitter objects.
  exports.augment = function(emitter) {
    emitter.listens = {};
    emitter.listenOn = function(k, fn) {
      var base;
      emitter.on(k, fn);
      if ((base = emitter.listens)[k] == null) {
        base[k] = [];
      }
      return emitter.listens[k].push(fn);
    };
    return emitter.unlisten = function() {
      var fn, fns, i, k, len, ref;
      ref = emitter.listens;
      for (k in ref) {
        fns = ref[k];
        for (i = 0, len = fns.length; i < len; i++) {
          fn = fns[i];
          emitter.removeListener(k, fn);
        }
      }
      return emitter.listens = {};
    };
  };

}).call(this);
