#!/usr/bin/env node

(function() {
  //!/usr/bin/env coffee

  // port-convert-bin.coffee    Copyright (c) 2017 Cloud Elements
  // All rights reserved. CLOUD ELEMENTS PROPRIETARY/CONFIDENTIAL.
  // Use is subject to license terms.

  // A simple executable to move a registry from a file into redis.
  var _, async, fs, rclient, redis, regUrl, warn;

  _ = require('lodash');

  redis = require('redis');

  async = require('async');

  fs = require('fs');

  regUrl = 'redis://localhost:6379';

  rclient = redis.createClient(regUrl);

  warn = function(...args) {
    console.log(...args);
    return rclient.quit();
  };

  rclient.del('g2c/openPorts', function(err) {
    var removeBads, takenPorts;
    if (err != null) {
      return console.log(err);
    }
    takenPorts = {};
    rclient.smembers('g2c/allids', function(err, ids) {
      return async.each(ids, function(id, cb) {
        return rclient.get(`g2c/ids/${id}/port`, function(err, port) {
          if (err != null) {
            return cb(err);
          }
          if (takenPorts[port] != null) {
            console.log(`Conflict on ${port}: ${takenPorts[port]} and ${id}`);
            return cb(null);
          }
          takenPorts[port] = id;
          return rclient.set(`g2c/ports/${port}`, id, cb);
        });
      }, function(err) {
        var i, j, results;
        if (err != null) {
          return console.log(err);
        }
        results = [];
        for (i = j = 11080; j <= 64000; i = ++j) {
          results.push((function(i) {
            if (takenPorts[i] == null) {
              console.log(`available: ${i}`);
              rclient.zadd('g2c/openPorts', 0, i, function(err) {
                if (err != null) {
                  return console.log(err);
                }
              });
            }
            if (i === 64000) {
              return removeBads(function() {
                return rclient.quit();
              });
            }
          })(i));
        }
        return results;
      });
    });
    return removeBads = function(cb) {
      console.log("removing bads");
      return rclient.keys('g2c/ports/*', function(err, pkeys) {
        console.log(`got ${pkeys.length} pkeys`);
        return async.each(pkeys, function(pkey, cb) {
          var port, slash;
          slash = pkey.lastIndexOf('/');
          port = pkey.substr(slash + 1);
          if (takenPorts[port] == null) {
            console.log(`deleting ${pkey}`);
            return rclient.del(pkey, cb);
          } else {
            return cb(null);
          }
        }, function(err) {
          if (err != null) {
            return console.log(err);
          }
          return cb();
        });
      });
    };
  });

}).call(this);
