(function() {
  //!/usr/bin/env coffee

  // port-convert-bin.coffee    Copyright (c) 2017 Cloud Elements
  // All rights reserved. CLOUD ELEMENTS PROPRIETARY/CONFIDENTIAL.
  // Use is subject to license terms.

  // A simple executable to move a registry from a file into redis.
  var _, akPath, async, forge, fs, home, path, rclient, redis, regUrl, shPath;

  _ = require('lodash');

  redis = require('redis');

  async = require('async');

  path = require('path');

  forge = require('node-forge');

  fs = require('fs');

  regUrl = 'redis://localhost:6379';

  rclient = redis.createClient(regUrl);

  home = process.env.HOME || process.env.USERPROFILE;

  shPath = path.join(home, '.ssh');

  akPath = path.join(shPath, 'authorized_keys.new');

  rclient.smembers('g2c/allids', function(err, ids) {
    return async.each(ids, function(id, cb) {
      return rclient.get(`g2c/ids/${id}/port`, function(err, port) {
        if (err != null) {
          return cb(err);
        }
        return rclient.get(`g2c/ids/${id}/key`, function(err, pubkeypem) {
          var pubkey, sshkey;
          if (err != null) {
            return cb(err);
          }
          try {
            pubkey = forge.pki.publicKeyFromPem(pubkeypem);
            sshkey = forge.ssh.publicKeyToOpenSSH(pubkey);
          } catch (error) {
            err = error;
            return cb(`problem on ${id}: ${err}`);
          }
          return fs.appendFile(akPath, `command=\"echo 'This login is restricted.'\",no-agent-forwarding,no-X11-forwarding,permitopen=\"localhost:${port}\" ${sshkey}\n`, {
            encoding: 'utf8'
          }, cb);
        });
      });
    }, function(err) {
      if (err != null) {
        console.warn(err);
      }
      console.log('done');
      return rclient.quit();
    });
  });

}).call(this);
