(function() {
  var guid, patches, registry, verifyConfig;

  registry = require('./registry_redis');

  patches = require('./patches');

  exports.guid = guid = function() {
    var s4;
    s4 = function() {
      return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
    };
    return s4() + s4() + s4() + s4();
  };

  exports.verifyConfig = verifyConfig = function(configPath, configData, cb) {
    return registry.manage(configPath, configData, function(err, registry) {
      if (err != null) {
        return cb(err);
      }
      configData.server.registry = registry;
      return patches.manage(configPath, configData, function(err, patches) {
        if (err != null) {
          return cb(err);
        }
        configData.server.patches = patches;
        return cb(null);
      });
    });
  };

  exports.toScore = function(val) {
    return new Date(val).getTime();
  };

  exports.nowScore = function() {
    return new Date().getTime();
  };

}).call(this);
