// Generated by CoffeeScript 1.10.0
(function() {
  var coffee, compile, deleteFolderRecursive, errout, extname, fs, jade, mkdirp, path, recurse, specials, stylus;

  fs = require('fs');

  path = require('path');

  mkdirp = require('mkdirp');

  coffee = function() {
    return require('coffeescript');
  };

  jade = function() {
    return require('jade');
  };

  stylus = function() {
    return require('stylus');
  };

  errout = function(msg, err) {
    console.error(msg);
    return process.exit(-1);
  };

  recurse = function(dop, fop) {
    var rfn;
    return rfn = function(srcpath, dstpath) {
      return fs.stat(srcpath, function(err, stats) {
        if (err != null) {
          return errout("Couldn't stat " + srcpath, err);
        }
        if (stats.isDirectory()) {
          return fs.readdir(srcpath, function(err, files) {
            if (err != null) {
              return errout("Couldn't read files in " + srcpath, err);
            }
            return dop(srcpath, dstpath, function(err) {
              var dp2, f, i, len, results, sp2;
              results = [];
              for (i = 0, len = files.length; i < len; i++) {
                f = files[i];
                sp2 = path.join(srcpath, f);
                dp2 = path.join(dstpath, f);
                results.push(rfn(sp2, dp2));
              }
              return results;
            });
          });
        } else if (stats.isFile()) {
          return fop(srcpath, dstpath, function(err) {
          });
        } else {
          return errout("Couldn't handle " + srcpath);
        }
      });
    };
  };

  extname = function(fn) {
    var en;
    en = path.extname(fn);
    if (en.length > 1) {
      return en.substr(1);
    } else {
      return en;
    }
  };

  compile = function(srcpath, dstpath) {
    var dop, fop;
    dop = function(sp, dp, cb) {
      return mkdirp(dp).then(cb);
    };
    fop = function(sp, dp, cb) {
      var doer, ext;
      ext = extname(sp);
      if ((doer = specials[ext]) != null) {
        return doer(sp, dp, cb);
      } else {
        return fs.readFile(sp, {}, function(err, srcbin) {
          if (err != null) {
            return cb("Couldn't read file " + sp + " " + err);
          }
          return fs.writeFile(dp, srcbin, {}, cb);
        });
      }
    };
    return recurse(dop, fop)(srcpath, dstpath);
  };

  deleteFolderRecursive = function(dpth) {
    if (fs.existsSync(dpth)) {
      fs.readdirSync(dpth).forEach(function(file, index) {
        var curPath;
        curPath = path.join(dpth, file);
        if (fs.lstatSync(curPath).isDirectory()) {
          return deleteFolderRecursive(curPath);
        } else {
          return fs.unlinkSync(curPath);
        }
      });
      return fs.rmdirSync(dpth);
    }
  };

  deleteFolderRecursive('lib');

  mkdirp('src').then(function(err) {
    return compile('src', 'lib');
  });

  specials = {
    coffee: function(sp, dp, cb) {
      dp = dp.substring(0, dp.length - 7) + '.js';
      return fs.readFile(sp, {
        encoding: 'utf8'
      }, function(err, srctext) {
        var dsttext;
        if (err != null) {
          return cb("Couldn't read file " + sp + " " + err);
        }
        dsttext = coffee().compile(srctext);
        if (dp.lastIndexOf('-bin.js') === dp.length - 7) {
          dsttext = "#!/usr/bin/env node\n\n" + dsttext;
        }
        return fs.writeFile(dp, dsttext, {
          encoding: 'utf8'
        }, function(err) {
          if (err != null) {
            return cb("Couldn't write file " + dp + " " + err);
          }
          if (dp.lastIndexOf('-bin.js') === dp.length - 7) {
            return fs.chmod(dp, 0x1ed, cb);
          } else {
            return cb(null);
          }
        });
      });
    },
    jade: function(sp, dp, cb) {
      dp = dp.substring(0, dp.length - 5) + '.html';
      return fs.readFile(sp, {
        encoding: 'utf8'
      }, function(err, srctext) {
        var dsttext, fn;
        if (err != null) {
          return cb("Couldn't read file " + sp + " " + err);
        }
        fn = jade().compile(srctext, {
          filename: sp,
          pretty: false
        });
        dsttext = fn({});
        return fs.writeFile(dp, dsttext, {
          encoding: 'utf8'
        }, function(err) {
          if (err != null) {
            return cb("Couldn't write file " + dp + " " + err);
          }
          return cb(null);
        });
      });
    },
    styl: function(sp, dp, cb) {
      dp = dp.substring(0, dp.length - 5) + '.css';
      return fs.readFile(sp, {
        encoding: 'utf8'
      }, function(err, srctext) {
        var dsttext;
        if (err != null) {
          return cb("Couldn't read file " + sp + " " + err);
        }
        dsttext = stylus().render(srctext);
        return fs.writeFile(dp, dsttext, {
          encoding: 'utf8'
        }, function(err) {
          if (err != null) {
            return cb("Couldn't write file " + dp + " " + err);
          }
          return cb(null);
        });
      });
    }
  };

}).call(this);
